/******/ (() => { // webpackBootstrap
navigator.serviceWorker.getRegistrations().then(function (registrations) {
  for (let registration of registrations) {
    registration.unregister();
  }
});

// https://developers.google.com/web/tools/workbox/guides/troubleshoot-and-debug
importScripts('https://storage.googleapis.com/workbox-cdn/releases/5.0.0-beta.1/workbox-sw.js');

// Install newest
// https://developers.google.com/web/tools/workbox/modules/workbox-core
workbox.core.skipWaiting();
workbox.core.clientsClaim();

// Cache static assets that aren't precached
workbox.routing.registerRoute(/\.(?:js|css|json5)$/, new workbox.strategies.StaleWhileRevalidate({
  cacheName: 'static-resources'
}));

// Cache the Google Fonts stylesheets with a stale-while-revalidate strategy.
workbox.routing.registerRoute(/^https:\/\/fonts\.googleapis\.com/, new workbox.strategies.StaleWhileRevalidate({
  cacheName: 'google-fonts-stylesheets'
}));

// Cache the underlying font files with a cache-first strategy for 1 year.
workbox.routing.registerRoute(/^https:\/\/fonts\.gstatic\.com/, new workbox.strategies.CacheFirst({
  cacheName: 'google-fonts-webfonts',
  plugins: [new workbox.cacheableResponse.CacheableResponsePlugin({
    statuses: [0, 200]
  }), new workbox.expiration.ExpirationPlugin({
    maxAgeSeconds: 60 * 60 * 24 * 365,
    // 1 Year
    maxEntries: 30
  })]
}));

// MESSAGE HANDLER
self.addEventListener('message', event => {
  if (event.data && event.data.type === 'SKIP_WAITING') {
    switch (event.data.type) {
      case 'SKIP_WAITING':
        // TODO: We'll eventually want this to be user prompted
        // workbox.core.skipWaiting();
        // workbox.core.clientsClaim();
        // TODO: Global notification to indicate incoming reload
        break;
      default:
        console.warn(`SW: Invalid message type: ${event.data.type}`);
    }
  }
});
workbox.precaching.precacheAndRoute([{'revision':null,'url':'/ohif/031089e563a18ada8441.wasm'},{'revision':null,'url':'/ohif/1185.bundle.63d4a7234e943a3bc2ab.js'},{'revision':null,'url':'/ohif/1266.bundle.336f6cdc0a45bd0e2c68.js'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/1266.css'},{'revision':null,'url':'/ohif/1374.bundle.8807bfaa6e4d720661ce.js'},{'revision':null,'url':'/ohif/149.bundle.b8d177954628f4631fc0.js'},{'revision':null,'url':'/ohif/1520.bundle.acba7d34f1203a4b294c.js'},{'revision':null,'url':'/ohif/17dd54813d5acc10bf8f.wasm'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/1801.css'},{'revision':null,'url':'/ohif/1927.bundle.40b115cd925087e88f6f.js'},{'revision':null,'url':'/ohif/2068.bundle.83ad900b6ad2110750da.js'},{'revision':null,'url':'/ohif/20fc4c659b85ccd2a9c0.wasm'},{'revision':null,'url':'/ohif/213.bundle.6c8181c7af2fb0c7bc7c.js'},{'revision':null,'url':'/ohif/2424.bundle.53106c4f226682af61ce.js'},{'revision':'aa1d1f3e32367e42fe90399144d94577','url':'/ohif/2591.css'},{'revision':null,'url':'/ohif/2701.bundle.8c1ff2e0faaa7d2f4716.js'},{'revision':null,'url':'/ohif/2825.bundle.4e16348f30e6284ae706.js'},{'revision':null,'url':'/ohif/3121.bundle.d3e7092e305cf6cecdb5.js'},{'revision':null,'url':'/ohif/3198.bundle.3b7b9a3138415c3ef46b.js'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/3198.css'},{'revision':null,'url':'/ohif/3200.bundle.db0cf63b692b184bf544.js'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/3200.css'},{'revision':null,'url':'/ohif/3334.bundle.0e6ba24024018199ab66.js'},{'revision':null,'url':'/ohif/3677.bundle.7d9110e8c5682b56a456.js'},{'revision':null,'url':'/ohif/3933.bundle.92d0a0e9bc7e6861b7c9.js'},{'revision':'5f41e01604320366f3031754abd247f3','url':'/ohif/3933.css'},{'revision':null,'url':'/ohif/3970.bundle.31942cc0c12a008e7ba0.js'},{'revision':null,'url':'/ohif/4033.bundle.8578ca2a967e3832ab3e.js'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/4182.css'},{'revision':null,'url':'/ohif/420.bundle.291b5ebcb0a0ee355147.js'},{'revision':null,'url':'/ohif/4202.bundle.5c8120ed4841da0af211.js'},{'revision':null,'url':'/ohif/4245.bundle.33acc03fe810fee508eb.js'},{'revision':null,'url':'/ohif/4571.bundle.3b1691730b3c57bf4d35.js'},{'revision':null,'url':'/ohif/4834.bundle.ef925a19b933346aceff.js'},{'revision':null,'url':'/ohif/5004fdc02f329ce53b69.wasm'},{'revision':null,'url':'/ohif/5139.bundle.944bf57903db186a93a1.js'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/5139.css'},{'revision':null,'url':'/ohif/5247.bundle.60530997a1279bc5e62d.js'},{'revision':'aa1d1f3e32367e42fe90399144d94577','url':'/ohif/5247.css'},{'revision':null,'url':'/ohif/5252.bundle.5ec502c53a9cc877ed8d.js'},{'revision':null,'url':'/ohif/5261.bundle.74682659cce85f3ae592.js'},{'revision':null,'url':'/ohif/5687.bundle.359725103be0568c6b27.js'},{'revision':null,'url':'/ohif/5717.bundle.bd70b52d202da3d0167a.js'},{'revision':null,'url':'/ohif/5807.bundle.dac5ce36534a71c77723.js'},{'revision':null,'url':'/ohif/5823.bundle.cb588e5e33eea80cd49f.js'},{'revision':null,'url':'/ohif/6939.bundle.9b79da82315a25f37d96.js'},{'revision':null,'url':'/ohif/7159.bundle.9f4856182f1eda29c59d.js'},{'revision':'20a92cf14c2d8be6cd580f68780cc7fa','url':'/ohif/7159.css'},{'revision':null,'url':'/ohif/717.bundle.335dd94fe25a2c2dd818.js'},{'revision':'a2676143017d8c0556e0d308fe358e44','url':'/ohif/717.css'},{'revision':null,'url':'/ohif/7197.bundle.805c43530f838fa98d40.js'},{'revision':'aa1d1f3e32367e42fe90399144d94577','url':'/ohif/7197.css'},{'revision':null,'url':'/ohif/732.bundle.532947c280e1a8f6e020.js'},{'revision':null,'url':'/ohif/7955.bundle.534d9e8491a096aa782e.js'},{'revision':null,'url':'/ohif/8008.bundle.a3dd38561f1a9418b099.js'},{'revision':null,'url':'/ohif/8094.bundle.411698eaf81975a7f12d.js'},{'revision':null,'url':'/ohif/8228.bundle.55ac03d7165248f47d4e.js'},{'revision':'c42dc07de7520381f78dc3bad8f028ca','url':'/ohif/8228.css'},{'revision':null,'url':'/ohif/8259.bundle.d0247cc870cb6a3cb048.js'},{'revision':null,'url':'/ohif/8295.bundle.4ecb27f9e58526f12bcb.js'},{'revision':null,'url':'/ohif/8523.bundle.648334132159465cdc41.js'},{'revision':null,'url':'/ohif/8558.bundle.36753f1c5becd7299a55.js'},{'revision':null,'url':'/ohif/9551.bundle.32397fa9d7acc4dd37af.js'},{'revision':null,'url':'/ohif/9611.bundle.767595c93877e5166c03.js'},{'revision':'2957caf9816ff0d04ccc6090c5da68b7','url':'/ohif/9611.css'},{'revision':null,'url':'/ohif/9862.bundle.7146682e56aa66130ae6.js'},{'revision':'d41d8cd98f00b204e9800998ecf8427e','url':'/ohif/_headers'},{'revision':'e3bf0f3e9c34f51ad59836ae8e8eaf43','url':'/ohif/_redirects'},{'revision':'90f3507aacb805ecfedb33d241f1061e','url':'/ohif/app-config.js'},{'revision':null,'url':'/ohif/app.bundle.af87d1dd396d277eac89.js'},{'revision':'f953db0ef4bf63c7274df8700050c0cd','url':'/ohif/app.bundle.css'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'/ohif/assets/android-chrome-144x144.png'},{'revision':'5cde390de8a619ebe55a669d2ac3effd','url':'/ohif/assets/android-chrome-192x192.png'},{'revision':'e7466a67e90471de05401e53b8fe20be','url':'/ohif/assets/android-chrome-256x256.png'},{'revision':'9bbe9b80156e930d19a4e1725aa9ddae','url':'/ohif/assets/android-chrome-36x36.png'},{'revision':'5698b2ac0c82fe06d84521fc5482df04','url':'/ohif/assets/android-chrome-384x384.png'},{'revision':'56bef3fceec344d9747f8abe9c0bba27','url':'/ohif/assets/android-chrome-48x48.png'},{'revision':'3e8b8a01290992e82c242557417b0596','url':'/ohif/assets/android-chrome-512x512.png'},{'revision':'517925e91e2ce724432d296b687d25e2','url':'/ohif/assets/android-chrome-72x72.png'},{'revision':'4c3289bc690f8519012686888e08da71','url':'/ohif/assets/android-chrome-96x96.png'},{'revision':'cf464289183184df09292f581df0fb4f','url':'/ohif/assets/apple-touch-icon-1024x1024.png'},{'revision':'0857c5282c594e4900e8b31e3bade912','url':'/ohif/assets/apple-touch-icon-114x114.png'},{'revision':'4208f41a28130a67e9392a9dfcee6011','url':'/ohif/assets/apple-touch-icon-120x120.png'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'/ohif/assets/apple-touch-icon-144x144.png'},{'revision':'977d293982af7e9064ba20806b45cf35','url':'/ohif/assets/apple-touch-icon-152x152.png'},{'revision':'6de91b4d2a30600b410758405cb567b4','url':'/ohif/assets/apple-touch-icon-167x167.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'/ohif/assets/apple-touch-icon-180x180.png'},{'revision':'647386c34e75f1213830ea9a38913525','url':'/ohif/assets/apple-touch-icon-57x57.png'},{'revision':'0c200fe83953738b330ea431083e7a86','url':'/ohif/assets/apple-touch-icon-60x60.png'},{'revision':'517925e91e2ce724432d296b687d25e2','url':'/ohif/assets/apple-touch-icon-72x72.png'},{'revision':'c9989a807bb18633f6dcf254b5b56124','url':'/ohif/assets/apple-touch-icon-76x76.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'/ohif/assets/apple-touch-icon-precomposed.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'/ohif/assets/apple-touch-icon.png'},{'revision':'05fa74ea9c1c0c3931ba96467999081d','url':'/ohif/assets/apple-touch-startup-image-1182x2208.png'},{'revision':'9e2cd03e1e6fd0520eea6846f4278018','url':'/ohif/assets/apple-touch-startup-image-1242x2148.png'},{'revision':'5591e3a1822cbc8439b99c1a40d53425','url':'/ohif/assets/apple-touch-startup-image-1496x2048.png'},{'revision':'337de578c5ca04bd7d2be19d24d83821','url':'/ohif/assets/apple-touch-startup-image-1536x2008.png'},{'revision':'cafb4ab4eafe6ef946bd229a1d88e7de','url':'/ohif/assets/apple-touch-startup-image-320x460.png'},{'revision':'d9bb9e558d729eeac5efb8be8d6111cc','url':'/ohif/assets/apple-touch-startup-image-640x1096.png'},{'revision':'038b5b02bac8b82444bf9a87602ac216','url':'/ohif/assets/apple-touch-startup-image-640x920.png'},{'revision':'2177076eb07b1d64d663d7c03268be00','url':'/ohif/assets/apple-touch-startup-image-748x1024.png'},{'revision':'4fc097443815fe92503584c4bd73c630','url':'/ohif/assets/apple-touch-startup-image-750x1294.png'},{'revision':'2e29914062dce5c5141ab47eea2fc5d9','url':'/ohif/assets/apple-touch-startup-image-768x1004.png'},{'revision':'f692ec286b3a332c17985f4ed38b1076','url':'/ohif/assets/browserconfig.xml'},{'revision':'f3d9a3b647853c45b0e132e4acd0cc4a','url':'/ohif/assets/coast-228x228.png'},{'revision':'ad6e1def5c66193d649a31474bbfe45d','url':'/ohif/assets/favicon-16x16.png'},{'revision':'84d1dcdb6cdfa55e2f46be0c80fa5698','url':'/ohif/assets/favicon-32x32.png'},{'revision':'95fb44c4998a46109e49d724c060db24','url':'/ohif/assets/favicon.ico'},{'revision':'5df2a5b0cee399ac0bc40af74ba3c2cb','url':'/ohif/assets/firefox_app_128x128.png'},{'revision':'11fd9098c4b07c8a07e1d2a1e309e046','url':'/ohif/assets/firefox_app_512x512.png'},{'revision':'27cddfc922dca3bfa27b4a00fc2f5e36','url':'/ohif/assets/firefox_app_60x60.png'},{'revision':'2547879ee2928a5fd56dca483bcbd967','url':'/ohif/assets/images/CT-AAA.png'},{'revision':'245628fb9d18d6c5cd529615079f8e86','url':'/ohif/assets/images/CT-AAA2.png'},{'revision':'997a9c8b57e7b4e46d8f01fb49d078c6','url':'/ohif/assets/images/CT-Air.png'},{'revision':'e7ed89711f63348d49898da3a2b73ab9','url':'/ohif/assets/images/CT-Bone.png'},{'revision':'09d1dc6efebb10a60cdf85ed74a10214','url':'/ohif/assets/images/CT-Bones.png'},{'revision':'f8ae9bafd3b90ba3efbdcbe8901db187','url':'/ohif/assets/images/CT-Cardiac.png'},{'revision':'ed0cc538aba90d6a1c029923ca9b47db','url':'/ohif/assets/images/CT-Cardiac2.png'},{'revision':'dfdaf4e4889aefbf09514545f45726bb','url':'/ohif/assets/images/CT-Cardiac3.png'},{'revision':'5d4b9a331136a1a5d7ce7ccf7dfcca36','url':'/ohif/assets/images/CT-Chest-Contrast-Enhanced.png'},{'revision':'5fb264499a5bb42487663b00e42d1513','url':'/ohif/assets/images/CT-Chest-Vessels.png'},{'revision':'ab8f0e569c972388ddaaa61b92449fac','url':'/ohif/assets/images/CT-Coronary-Arteries-2.png'},{'revision':'e4e7e2e3cc09bc8c4fb03b6441bd2845','url':'/ohif/assets/images/CT-Coronary-Arteries-3.png'},{'revision':'79a2962a2d3cbe4bd3b675b5ca83c659','url':'/ohif/assets/images/CT-Coronary-Arteries.png'},{'revision':'6502a6bdab1c70e2188c3bf12ce5d4e4','url':'/ohif/assets/images/CT-Cropped-Volume-Bone.png'},{'revision':'e28ad3cf5ed2006fc5a7cffd602736fc','url':'/ohif/assets/images/CT-Fat.png'},{'revision':'ca1c5be76053edee27e68ffbf9105101','url':'/ohif/assets/images/CT-Liver-Vasculature.png'},{'revision':'d6c9ab857ed2ad19f1ff20bea02b6655','url':'/ohif/assets/images/CT-Lung.png'},{'revision':'ddb599c6a163bdf28ece8de1a337470a','url':'/ohif/assets/images/CT-MIP.png'},{'revision':'0b0dcf7940a555e2a9a0900f7f84d4d3','url':'/ohif/assets/images/CT-Muscle.png'},{'revision':'6082d383f9ce375a5873e2a00fc4d372','url':'/ohif/assets/images/CT-Pulmonary-Arteries.png'},{'revision':'b317366149ee2607bec95d63eb4d7661','url':'/ohif/assets/images/CT-Soft-Tissue.png'},{'revision':'4b0cd5a673ebb71da22a91ed608d6695','url':'/ohif/assets/images/DTI-FA-Brain.png'},{'revision':'3ea1cbee022af5b94710b73726308832','url':'/ohif/assets/images/MR-Angio.png'},{'revision':'bd25ca7b166193547f34950eed440e5c','url':'/ohif/assets/images/MR-Default.png'},{'revision':'2e50a49b859aeb316a1c23f911fce9ad','url':'/ohif/assets/images/MR-MIP.png'},{'revision':'6ba74de6961e08652ff9e2f1871b473d','url':'/ohif/assets/images/MR-T2-Brain.png'},{'revision':'42406bb474f0f87cf04a5afbbcd5e389','url':'/ohif/assets/images/VolumeRendering.png'},{'revision':'2ac2b0ce7f302b5c453538bad5990766','url':'/ohif/assets/images/action-new-dialog.svg'},{'revision':'109a2e1a374e79539525fe80e10942be','url':'/ohif/assets/images/arrow-down.svg'},{'revision':'bed58bf39fce08f240e6506c8a531127','url':'/ohif/assets/images/arrow-left-small.svg'},{'revision':'ff1fb35eedad24cbfcd8f9e649d4dc77','url':'/ohif/assets/images/arrow-left.svg'},{'revision':'14b79182653ac2c4b751de35530a0a6b','url':'/ohif/assets/images/arrow-right-small.svg'},{'revision':'ff1fb35eedad24cbfcd8f9e649d4dc77','url':'/ohif/assets/images/arrow-right.svg'},{'revision':'60068b541aef395c0810e78240cf932d','url':'/ohif/assets/images/calendar.svg'},{'revision':'3be31df1ed2feb64d3546e6df81abee6','url':'/ohif/assets/images/cancel.svg'},{'revision':'dd10a9e288e3c735f6c0e94a82834c1a','url':'/ohif/assets/images/checkbox-active.svg'},{'revision':'ef9a34c6125c60320d569c1dc6c7e089','url':'/ohif/assets/images/checkbox-checked.svg'},{'revision':'418af47ff27d79ee3af331655c2a4ae2','url':'/ohif/assets/images/checkbox-default.svg'},{'revision':'4190dc26fd7c153ed1ff68a42bc6146c','url':'/ohif/assets/images/checkbox-unchecked.svg'},{'revision':'8c8377d2ce6fe13d808d7b3bbcd9db4f','url':'/ohif/assets/images/chevron-down.svg'},{'revision':'18d8c802690c58715e7e683167ef466a','url':'/ohif/assets/images/chevron-left.svg'},{'revision':'3ce9187b607d0dc54a87b2be3a3d4045','url':'/ohif/assets/images/chevron-menu.svg'},{'revision':'49dd91537cefd49f64b8aaa70f6e808e','url':'/ohif/assets/images/chevron-next.svg'},{'revision':'aab87d839a17619360ce69310d1f488e','url':'/ohif/assets/images/chevron-prev.svg'},{'revision':'b0dc9111715d746118509922884b483d','url':'/ohif/assets/images/chevron-right.svg'},{'revision':'a806e43fe58f8592a282ac5048422911','url':'/ohif/assets/images/circled-checkmark.svg'},{'revision':'90986c24cfab07d2bb76379c2082db0a','url':'/ohif/assets/images/clipboard.svg'},{'revision':'148a355c60fde85ec21aebbe279040ea','url':'/ohif/assets/images/closeIcon.svg'},{'revision':'721c3abc16d32cd6420730250db16cfd','url':'/ohif/assets/images/content-next.svg'},{'revision':'30c6e1686d37132388d2c16ba05c05ab','url':'/ohif/assets/images/content-prev.svg'},{'revision':'c05234cc35b7909b6fcf363e399a790f','url':'/ohif/assets/images/database.svg'},{'revision':'e1ffa1b2fc827c0888594a3537ff583f','url':'/ohif/assets/images/dotted-circle.svg'},{'revision':'41934992e61099781d838f66c1c40ff4','url':'/ohif/assets/images/edit-patient.svg'},{'revision':'d0f28f2519ae3e9a5b9ba78f6ff58cfe','url':'/ohif/assets/images/exclamation.svg'},{'revision':'a315ab7700a4f7058e76115371718660','url':'/ohif/assets/images/external-link.svg'},{'revision':'ee3fbd44f9d6ee5471beecbdf97d26a0','url':'/ohif/assets/images/eye-hidden.svg'},{'revision':'08a50f25e1627a18858f61bdf55841cd','url':'/ohif/assets/images/eye-visible.svg'},{'revision':'4dcfe9b236c89104359a5d352eeb7e07','url':'/ohif/assets/images/focus-frame-target.svg'},{'revision':'8f18a33befea1d060fab88c8cd07922a','url':'/ohif/assets/images/group-layers.svg'},{'revision':'a7f69428d6c0df34b40d78063a1cb3a0','url':'/ohif/assets/images/icon-add.svg'},{'revision':'4bba68aa6036d3a2a2cf2ea8b104aa96','url':'/ohif/assets/images/icon-alert-small.svg'},{'revision':'ea5d595eec497abe59b551a2e7fb1c40','url':'/ohif/assets/images/icon-chevron-patient.svg'},{'revision':'247329b2b8f99fde3f719df6e9c11df4','url':'/ohif/assets/images/icon-clear-field.svg'},{'revision':'4f3ece2971c8dec4785f90b59e187309','url':'/ohif/assets/images/icon-close.svg'},{'revision':'82a78456a4953503f520cf35d14e491c','url':'/ohif/assets/images/icon-color-lut.svg'},{'revision':'dafd517705a2219b694a6d00f8cfd9e6','url':'/ohif/assets/images/icon-delete.svg'},{'revision':'390fff004959ad75768b8f327bd45c96','url':'/ohif/assets/images/icon-disclosure-close.svg'},{'revision':'ed8a9787d3a6db903e1770f4747ec768','url':'/ohif/assets/images/icon-disclosure-open.svg'},{'revision':'4c8f68d725be5e2665b774e791e6b04d','url':'/ohif/assets/images/icon-display-settings.svg'},{'revision':'16b88f0b4a8a0f64cda53f90009ee9d8','url':'/ohif/assets/images/icon-more-menu.svg'},{'revision':'ffdf8d0104dd1cb039fbef2014f9fa69','url':'/ohif/assets/images/icon-mpr-alt.svg'},{'revision':'6f6428ccdabef44cb11a34ba03b6183a','url':'/ohif/assets/images/icon-multiple-patients.svg'},{'revision':'52dd7618979598caccd2977e38a5c901','url':'/ohif/assets/images/icon-next-inactive.svg'},{'revision':'1ddadee14a0753766c2f9b67929b23a5','url':'/ohif/assets/images/icon-next.svg'},{'revision':'eea004288ceea8b8ca79ce0d3fd26bdd','url':'/ohif/assets/images/icon-patient.svg'},{'revision':'2f276ed9e2ea6d95b7a28a011a185fdd','url':'/ohif/assets/images/icon-pause.svg'},{'revision':'1e0d1f40b59af92b6efb0d808794b3ed','url':'/ohif/assets/images/icon-play.svg'},{'revision':'fef32c916923f4eab4db2d8f8bea547b','url':'/ohif/assets/images/icon-prev-inactive.svg'},{'revision':'f51af0195ff55097e14e2eea781dd5ec','url':'/ohif/assets/images/icon-prev.svg'},{'revision':'9779c795665705f4d5ce7019025bec57','url':'/ohif/assets/images/icon-rename.svg'},{'revision':'5a0296ef83f91813df78ff0953031d7b','url':'/ohif/assets/images/icon-search.svg'},{'revision':'9be02b167382c62b5edae24db9821747','url':'/ohif/assets/images/icon-settings.svg'},{'revision':'436c34f96427913428a6329636b14367','url':'/ohif/assets/images/icon-status-alert.svg'},{'revision':'21a620eb00dd1ec5725461d1c3d21411','url':'/ohif/assets/images/icon-tool-scissor.svg'},{'revision':'4f89c73e6b66ad7d5bbea928a6322962','url':'/ohif/assets/images/icon-toolbar-back.svg'},{'revision':'cd72165cbf374e8fcdb39c8a7efd4e95','url':'/ohif/assets/images/icon-transferring.svg'},{'revision':'429e5d3b20cdc0b263b143ceccdab6f6','url':'/ohif/assets/images/icon-upload.svg'},{'revision':'e848e9d9689281ea9e988228bdabd6e4','url':'/ohif/assets/images/icons-alert-outline.svg'},{'revision':'0fa801274f2e98e27973af9a61ba6d38','url':'/ohif/assets/images/illustration-investigational-use.svg'},{'revision':'c973fbf2681cc63500c0b4a628f72403','url':'/ohif/assets/images/info-action.svg'},{'revision':'8be86fe5042a0a5c81caa80335317ccc','url':'/ohif/assets/images/info-link.svg'},{'revision':'4786fff8fca1a91d1390e40d8a9aa5e8','url':'/ohif/assets/images/info.svg'},{'revision':'bf4d24b632fab6677aec8e5727b4ac58','url':'/ohif/assets/images/launch-arrow.svg'},{'revision':'57c058e4f9ccf836b924828f651d39fa','url':'/ohif/assets/images/launch-info.svg'},{'revision':'700491835b2e2f87b976662f4c6a1442','url':'/ohif/assets/images/layout-advanced-3d-four-up.svg'},{'revision':'2fa35fb584c191d3499f5670953f38f5','url':'/ohif/assets/images/layout-advanced-3d-main.svg'},{'revision':'be9820cd8441103429d4c4f8aaf7b351','url':'/ohif/assets/images/layout-advanced-3d-only.svg'},{'revision':'75a558338e327250a697c09bdf572ee3','url':'/ohif/assets/images/layout-advanced-3d-primary.svg'},{'revision':'8cd05a45785004aa684050e670690cb9','url':'/ohif/assets/images/layout-advanced-axial-primary.svg'},{'revision':'2d1023f429de24d1595e06df9d5ee537','url':'/ohif/assets/images/layout-advanced-mpr.svg'},{'revision':'f726a7a188d76fbc481f8cc572d63936','url':'/ohif/assets/images/layout-common-1x1.svg'},{'revision':'a0076b00269fec1dcc38e76ccde89d30','url':'/ohif/assets/images/layout-common-1x2.svg'},{'revision':'57170774d76e301998fcc9fba5569a05','url':'/ohif/assets/images/layout-common-2x2.svg'},{'revision':'972724c5fac9094ef4d2676921b5f08f','url':'/ohif/assets/images/layout-common-2x3.svg'},{'revision':'46028151742d6439bc1c753316824254','url':'/ohif/assets/images/list-bullets.svg'},{'revision':'8eeed85acf098ee26094675806b53e6b','url':'/ohif/assets/images/loading-ohif-mark.svg'},{'revision':'5b20a8439cb79e5b47089cf8c10f830b','url':'/ohif/assets/images/lock.svg'},{'revision':'413d7777da6dafd92a78c507f42183a7','url':'/ohif/assets/images/logo-ohif-small.svg'},{'revision':'ced506c4a08b442ba35d2ce5779be0e1','url':'/ohif/assets/images/magnifier.svg'},{'revision':'9aed3d9a4ec0eca5075d1a56cbaa4325','url':'/ohif/assets/images/navigation-panel-right-hide.svg'},{'revision':'546b01900d8975de96e845d03b659f34','url':'/ohif/assets/images/navigation-panel-right-reveal.svg'},{'revision':'b05e590d66ad29276cbd0f6f0464cc9f','url':'/ohif/assets/images/next-arrow.svg'},{'revision':'436c34f96427913428a6329636b14367','url':'/ohif/assets/images/notifications-error.svg'},{'revision':'799c9177a83224aca93a2d1b472bfd25','url':'/ohif/assets/images/notifications-info.svg'},{'revision':'53b57edba13a95a7e6fc64a25372d77b','url':'/ohif/assets/images/notifications-success.svg'},{'revision':'f47010b023c47c19f6f7ae592dc38529','url':'/ohif/assets/images/notifications-warning.svg'},{'revision':'ab1d99cbb1b04f049b482a6f937f2d09','url':'/ohif/assets/images/notificationwarning-diamond.svg'},{'revision':'c27daec1059aad403695c3e8ee7c9385','url':'/ohif/assets/images/ohif-logo-color-darkbg.svg'},{'revision':'73f15b1cfde48d088d2ffb13ca9eb597','url':'/ohif/assets/images/ohif-logo.svg'},{'revision':'4b88d6807831a5f4c5ec58ae02f7c424','url':'/ohif/assets/images/old-play.svg'},{'revision':'d6aee51c1c10826b4dd64509f1e1c267','url':'/ohif/assets/images/old-stop.svg'},{'revision':'1a012dbcd25d3d974f0df1428ed3e92a','url':'/ohif/assets/images/old-trash.svg'},{'revision':'ffcfa0839e16fd00184a2b4aa685b235','url':'/ohif/assets/images/panel-group-more.svg'},{'revision':'49d8a02c02d1d05f04bd76aadce4b3e1','url':'/ohif/assets/images/panel-group-open-close.svg'},{'revision':'946ba16feb11dd035c3b3a497120f821','url':'/ohif/assets/images/pencil.svg'},{'revision':'73305f54b34caec029090239481efcd7','url':'/ohif/assets/images/power-off.svg'},{'revision':'636f67b35d43a22b8dae8ff123e28561','url':'/ohif/assets/images/prev-arrow.svg'},{'revision':'ff7f2780c19075457235fc14ce4915df','url':'/ohif/assets/images/profile.svg'},{'revision':'0253dc09f01fdfe7787e8c6839d8c1a8','url':'/ohif/assets/images/push-left.svg'},{'revision':'68d62e4798252dc2b3d6acbd40c902f7','url':'/ohif/assets/images/push-right.svg'},{'revision':'3ba30572b3b060b7194755c7de34da07','url':'/ohif/assets/images/row-add.svg'},{'revision':'3eb48638b1e305c301706c467f3701e3','url':'/ohif/assets/images/row-edit.svg'},{'revision':'8e1af97d6fc1ce60ae1438f16f6d0a00','url':'/ohif/assets/images/row-hidden.svg'},{'revision':'803bde50082b4befe82f4731cf2905b2','url':'/ohif/assets/images/row-lock.svg'},{'revision':'7cb0f8b6c2a100ac1260e0915cd2678b','url':'/ohif/assets/images/row-shown.svg'},{'revision':'9e74f285e5fc0945ac73ae45d29fb8a8','url':'/ohif/assets/images/row-unlock.svg'},{'revision':'af0f50fab949176d5a13fe7c36dd06c5','url':'/ohif/assets/images/settings.svg'},{'revision':'a36187c7f1dd042891d650c2058eb3ed','url':'/ohif/assets/images/side-panel-close-left.svg'},{'revision':'d5e0351c1624f8d26b957bc4f42fbeb8','url':'/ohif/assets/images/side-panel-close-right.svg'},{'revision':'0d3992fca6afbc40469c2f376396d0d6','url':'/ohif/assets/images/sorting-active-down.svg'},{'revision':'ee8d368209d4d1f3ab5c9fb6f67ae453','url':'/ohif/assets/images/sorting-active-up.svg'},{'revision':'46438b9892e5102049502ace1ad710db','url':'/ohif/assets/images/sorting.svg'},{'revision':'f73f98771507e91e7341343d9145743e','url':'/ohif/assets/images/status-alert-warning.svg'},{'revision':'6f772bc83f99dc88c5e1012c780d2c3f','url':'/ohif/assets/images/status-alert.svg'},{'revision':'86323c5abbefb71b92a07e7ccec3e3ac','url':'/ohif/assets/images/status-locked.svg'},{'revision':'9a0ff18994a66803a50f4e1df5b8973d','url':'/ohif/assets/images/status-tracked.svg'},{'revision':'3cee5382712efe24cab0b3644dade640','url':'/ohif/assets/images/status-untracked.svg'},{'revision':'198a7eab9baf0ed11faff44b8eb1b110','url':'/ohif/assets/images/tab-4d.svg'},{'revision':'4acb6f7dec4d047785e81ed0238f79bd','url':'/ohif/assets/images/tab-linear.svg'},{'revision':'f50ac663f3ee03947a4abd0dd884783b','url':'/ohif/assets/images/tab-patient-info.svg'},{'revision':'0e953d7ae34d2f57e3f62a62f8c5d654','url':'/ohif/assets/images/tab-roi-threshold.svg'},{'revision':'9836815249d39ab815811e2573626fb3','url':'/ohif/assets/images/tab-segmentation.svg'},{'revision':'881ebf83c3868993cc25283ffd8de4f9','url':'/ohif/assets/images/tab-studies.svg'},{'revision':'2b6063491d9eb5c83bffa5a4f884dffc','url':'/ohif/assets/images/tool-3d-rotate.svg'},{'revision':'465e55e1d4d3560c63dfeb5a8509a37f','url':'/ohif/assets/images/tool-angle.svg'},{'revision':'56451d25aa38a5f7368930a5a4e11993','url':'/ohif/assets/images/tool-annotate.svg'},{'revision':'826237b69bf091c5ab168ccf772b3f6b','url':'/ohif/assets/images/tool-bidirectional.svg'},{'revision':'2a0819d37da1ede1968565c10883da71','url':'/ohif/assets/images/tool-calibrate.svg'},{'revision':'298a38dfebb193d7d9430d1da65ccafe','url':'/ohif/assets/images/tool-capture.svg'},{'revision':'30b3ff8b894614faf3c258bdcdba19e7','url':'/ohif/assets/images/tool-cine.svg'},{'revision':'8270bf6adafbf2eb91b492f823ff5b59','url':'/ohif/assets/images/tool-circle.svg'},{'revision':'9ea339f993c77d61525c2a80bb680fcd','url':'/ohif/assets/images/tool-cobb-angle.svg'},{'revision':'6894f30a2535802a7bc4eb4e32fb9d76','url':'/ohif/assets/images/tool-create-threshold.svg'},{'revision':'125db83a8f108c75d5f7c273d6b5eb6d','url':'/ohif/assets/images/tool-crosshair.svg'},{'revision':'5efc207d05b3406ac8a697cba733d504','url':'/ohif/assets/images/tool-dicom-tag-browser.svg'},{'revision':'6321434ff71ac12c8a6500d896baee65','url':'/ohif/assets/images/tool-flip-horizontal.svg'},{'revision':'b743623b15a091489d5796c38111a9fd','url':'/ohif/assets/images/tool-freehand-polygon.svg'},{'revision':'303e00d5fec68d44094d6e250709e7a4','url':'/ohif/assets/images/tool-freehand-roi.svg'},{'revision':'9a7b817a02eb72681d63eb2f8621b0a6','url':'/ohif/assets/images/tool-freehand.svg'},{'revision':'0a19b830b9e6aab442bbc315ddcadda1','url':'/ohif/assets/images/tool-fusion-color.svg'},{'revision':'e24717ad99cd79d25d0ea9ddb5cca933','url':'/ohif/assets/images/tool-invert.svg'},{'revision':'53876002f0022a86258a40be10995d91','url':'/ohif/assets/images/tool-layout-default.svg'},{'revision':'84a983f7bc28c794a1c787ed60e93039','url':'/ohif/assets/images/tool-length.svg'},{'revision':'0a0752163d7d8ed7e8030e4ba867d94d','url':'/ohif/assets/images/tool-magnetic-roi.svg'},{'revision':'55499c759c030b66d274d6cec9cc4edf','url':'/ohif/assets/images/tool-magnify.svg'},{'revision':'6a15d259ba1c8d1a7f472ed48ccfbea8','url':'/ohif/assets/images/tool-measure-elipse.svg'},{'revision':'34749c2178803fc73d0f653d8174fbc9','url':'/ohif/assets/images/tool-more-menu.svg'},{'revision':'503841dc572676a8c4373fad16df6e28','url':'/ohif/assets/images/tool-move.svg'},{'revision':'d266f52c36177fbf3f536def9411e0a9','url':'/ohif/assets/images/tool-polygon.svg'},{'revision':'7de4f217d73653f222d8699df3ecc9dd','url':'/ohif/assets/images/tool-quick-magnify.svg'},{'revision':'0959bf47b7f68561ea1cc11293b550dc','url':'/ohif/assets/images/tool-rectangle.svg'},{'revision':'9d2737c0e4752ac9f6a59856f9fea4c2','url':'/ohif/assets/images/tool-reference-lines.svg'},{'revision':'7d09a0d18de9644f00958d05111ce781','url':'/ohif/assets/images/tool-reset.svg'},{'revision':'791024978827f35007fd2c10f56d41f5','url':'/ohif/assets/images/tool-rotate-right.svg'},{'revision':'ac53ce270acb07fc08062c494ddbc5ef','url':'/ohif/assets/images/tool-seg-brush.svg'},{'revision':'ad38fa864f82b2dd9b54a922e22a3f91','url':'/ohif/assets/images/tool-seg-eraser.svg'},{'revision':'ba2f73241f275561a74523ecb715a91d','url':'/ohif/assets/images/tool-seg-shape.svg'},{'revision':'4ff3126248cc5398e6b1e655893ebd2e','url':'/ohif/assets/images/tool-seg-threshold.svg'},{'revision':'db1fa0214073643de6289a3698f867e3','url':'/ohif/assets/images/tool-spline-roi.svg'},{'revision':'3f61ff5e5515499f4b3409afb7b573cb','url':'/ohif/assets/images/tool-stack-image-sync.svg'},{'revision':'1f596aef82e090110d51b989f1a08d6e','url':'/ohif/assets/images/tool-stack-scroll.svg'},{'revision':'cb932e183e5fe35573050c7e902e8c4b','url':'/ohif/assets/images/tool-toggle-dicom-overlay.svg'},{'revision':'25fc934e962c7df52199c10a8e0f0084','url':'/ohif/assets/images/tool-ultrasound-bidirectional.svg'},{'revision':'417b35e1c59417db9fe34c566f2f086e','url':'/ohif/assets/images/tool-window-level.svg'},{'revision':'d3e2c18e24feb7ddbcf90068b8f1e7a0','url':'/ohif/assets/images/tool-window-region.svg'},{'revision':'112b50b7fc1e7f1437daf041d617d1b0','url':'/ohif/assets/images/tool-zoom.svg'},{'revision':'a806e43fe58f8592a282ac5048422911','url':'/ohif/assets/images/tracked.svg'},{'revision':'40c03a4c53184ce87538e185f9750de3','url':'/ohif/assets/images/ui-arrow-down.svg'},{'revision':'50ce5cab66d2dc254375af49c3cefb81','url':'/ohif/assets/images/ui-arrow-left.svg'},{'revision':'d025139b083682450cd811e84487898b','url':'/ohif/assets/images/ui-arrow-right.svg'},{'revision':'0e1984794e94d7aff308276ef9080478','url':'/ohif/assets/images/ui-arrow-up.svg'},{'revision':'8eaba109c16992fe4cc4bdc6d4890639','url':'/ohif/assets/images/unlink.svg'},{'revision':'e411fc3987fc6829bd05b13b296d7aea','url':'/ohif/assets/images/viewport-status-tracked.svg'},{'revision':'e08187ca159c1cd7f1381568e94a1fe4','url':'/ohif/assets/images/viewport-window-level.svg'},{'revision':'2017d95fae79dcf34b5a5b52586d4763','url':'/ohif/assets/manifest.webapp'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'/ohif/assets/mstile-144x144.png'},{'revision':'334895225e16a7777e45d81964725a97','url':'/ohif/assets/mstile-150x150.png'},{'revision':'e295cca4af6ed0365cf7b014d91b0e9d','url':'/ohif/assets/mstile-310x150.png'},{'revision':'cbefa8c42250e5f2443819fe2c69d91e','url':'/ohif/assets/mstile-310x310.png'},{'revision':'aa411a69df2b33a1362fa38d1257fa9d','url':'/ohif/assets/mstile-70x70.png'},{'revision':'5609af4f69e40e33471aee770ea1d802','url':'/ohif/assets/yandex-browser-50x50.png'},{'revision':'dd001f21b3970d5a7f3e245cc10d21df','url':'/ohif/assets/yandex-browser-manifest.json'},{'revision':null,'url':'/ohif/c22b37c3488e1d6c3aa4.wasm'},{'revision':'c377e1f5fe4a207d270c3f7a8dd3e3ca','url':'/ohif/dicom-microscopy-viewer/5004fdc02f329ce53b69.wasm'},{'revision':'ce10eced3ce34e663d86569b27f5bffb','url':'/ohif/dicom-microscopy-viewer/65916ef3def695744bda.wasm'},{'revision':'52b9a07fe0541fe8c313d9788550bf51','url':'/ohif/dicom-microscopy-viewer/b6b803111e2d06a825bd.wasm'},{'revision':'7edb59d2be7c993050cb31ded36afa31','url':'/ohif/dicom-microscopy-viewer/c22b37c3488e1d6c3aa4.wasm'},{'revision':'eaa70476e800651625c9e5de4501edef','url':'/ohif/dicom-microscopy-viewer/dicomMicroscopyViewer.min.js'},{'revision':'18464c31a0a171555ad626dc059cce2d','url':'/ohif/dicom-microscopy-viewer/dicomMicroscopyViewer.min.js.LICENSE.txt'},{'revision':'254380a19b838537d422eaf69c116b45','url':'/ohif/dicom-microscopy-viewer/dicomMicroscopyViewer.min.js.map'},{'revision':'91e3d8268b5314586d6f30676b2fab6c','url':'/ohif/dicom-microscopy-viewer/index.worker.min.worker.js'},{'revision':'8f4b222d2efaaf0f1c6372a33b2ee132','url':'/ohif/dicom-microscopy-viewer/index.worker.min.worker.js.map'},{'revision':'4acdd19a35d759ec2669f1ba9490937d','url':'/ohif/es6-shim.min.js'},{'revision':'966afc6cb727ef212a75802f2020834e','url':'/ohif/google.js'},{'revision':null,'url':'/ohif/histogram-worker.bundle.118d553b53a573660111.js'},{'revision':'4468c5bd8b440056c163f0f64e9d3a05','url':'/ohif/index.html'},{'revision':'31c0367ca4160b2c6373e905739c5719','url':'/ohif/init-service-worker.js'},{'revision':'74fc9658b62903be2048c1f82a22b4d4','url':'/ohif/manifest.json'},{'revision':'3fa71aa0af3e34b4ebd9a71eee0f4bdd','url':'/ohif/ohif-logo-light.svg'},{'revision':'7e81da785c63e75650101db6c5d7560e','url':'/ohif/ohif-logo.svg'},{'revision':'eadf8bf1d85032a029e2c0df4b8938b0','url':'/ohif/oidc-client.min.js'},{'revision':null,'url':'/ohif/polySeg.bundle.50d93b9ce5a52f05c879.js'},{'revision':'a1aef5311245f5864315443d12246c37','url':'/ohif/polyfill.min.js'},{'revision':'af9346d3e597071ba9ee8cd32f8cc0ea','url':'/ohif/serve.json'},{'revision':'b1e488d9955b62bd2858874df11d5223','url':'/ohif/silent-refresh.html'},{'revision':null,'url':'/ohif/suv-peak-worker.bundle.14e55a14a63a983acccb.js'}]);

// TODO: Cache API
// https://developers.google.com/web/fundamentals/instant-and-offline/web-storage/cache-api
// Store DICOMs?
// Clear Service Worker cache?
// navigator.storage.estimate().then(est => console.log(est)); (2GB?)
/******/ })()
;